﻿#target indesign;

if (parseInt (app.version) > 5 && app.documents.length > 0)
		stack_notes ('sidenote');

// =============================================================================

function stack_notes (stylename)
	{
	var stack = get_position ();
	$.writeln (stack.space)
	var measure = set_measure (MeasurementUnits.points);
	switch (stack.target)
		{
		case "document": stack_document (stack); break;
		case "textframe": stack_frame (app.selection[0], stack); break
		}
	restore_measure (measure)
	}


function stack_document (stack)
	{
	var frame_IDs = find_noted_frames ();
	for (var i = 0; i < frame_IDs.length; i++)
		stack_frame (app.documents[0].textFrames.itemByID (frame_IDs[i]), stack)
	}


function stack_frame (tf, stack)
	{
	switch (stack.position)
		{
		case "top": stack_notes_top (tf, stack.space); break;
		case "centre": stack_notes_centre (tf, stack.space); break;
		case "bottom": stack_notes_bottom (tf, stack.space);
		}
	}


function stack_notes_centre (tf, v_space)
	{
	var notes = tf.textFrames;
	if (notes[0].geometricBounds[0] != tf.geometricBounds[0])
		stack_notes_top (tf, v_space);
	var note_centre = notes[0].geometricBounds[0] + ((notes[-1].geometricBounds[2] - notes[0].geometricBounds[0])/2);
	var frame_centre = tf.geometricBounds[0] + ((tf.geometricBounds[2] - tf.geometricBounds[0])/2);
	var difference = frame_centre - note_centre;
	for (var i = 0; i < notes.length; i++)
		notes[i].anchoredObjectSettings.anchorYoffset += difference
	}


function stack_notes_top (tf, v_space)
	{
	var notes = tf.textFrames;
	var target = tf.geometricBounds[0];
	notes[0].anchoredObjectSettings.anchorYoffset = 0;
	var offset = target - notes[0].geometricBounds[0];
	notes[0].anchoredObjectSettings.anchorYoffset = offset;
	for (var i = 1; i < notes.length; i++)
		{
		target = notes[i-1].geometricBounds[2] + v_space;
		notes[i].anchoredObjectSettings.anchorYoffset = 0;
		offset = target - notes[i].geometricBounds[0];
		notes[i].anchoredObjectSettings.anchorYoffset = offset;
		}
	}


function stack_notes_bottom (tf, v_space)
	{
	var notes = tf.textFrames;
	var target = tf.geometricBounds[2];
	notes[-1].anchoredObjectSettings.anchorYoffset = 0;
	var offset = target - notes[-1].geometricBounds[2];
	notes[-1].anchoredObjectSettings.anchorYoffset = offset;
	for (var i = notes.length-2; i > -1; i--)
		{
		target = notes[i+1].geometricBounds[0] - v_space;
		notes[i].anchoredObjectSettings.anchorYoffset = 0;
		offset = target - notes[i].geometricBounds[2];
		notes[i].anchoredObjectSettings.anchorYoffset = offset;
		}
	}
// =================================================================================================

// Return the IDs of the textframes that contain sidenotes, unique values only

function find_noted_frames ()
	{
	var parent_id;
	app.findObjectPreferences = null;
	app.findObjectPreferences.appliedObjectStyles = app.documents[0].objectStyles.item ("sidenote");
	var f = app.documents[0].findObject();
	var known = [];
	var array = [];
	for (var i = 0; i < f.length; i++)
		{
		parent_id = f[i].parent.parentTextFrames[0].id;
		if (!known[parent_id])
			{
			array.push (parent_id);
			known[parent_id] = true;
			}
		}
	return array
	}

// Interface =========================================================================================

function get_position ()
	{
	var w = new Window ('dialog', 'Расположение маргиналий');
		var main = w.add ('panel');
		main.alignChildren = 'fill';
		var g1 = main.add ('panel');
			g1.alignChildren = ['left', 'top'];
			g1.orientation = 'column';
			var vpos = [];
			vpos[0] = g1.add ('radiobutton', undefined, " По верхней границе фрейма\u00A0");
			vpos[1] = g1.add ('radiobutton', undefined, " По центру фрейма\u00A0");
			vpos[2] = g1.add ('radiobutton', undefined, " По нижней границе фрейма\u00A0");
			vpos[0].value = true;
		var g2 = main.add ('panel');
			g2.alignChildren = ['left', 'top'];
			g2.orientation = 'column';
			var scope = [];
			scope[0] = g2.add ('radiobutton', undefined, " Весь документ\u00A0");
			scope[1] = g2.add ('radiobutton', undefined, " Только выделенный фрейм\u00A0");
		var sp = main.add ('group');
			sp.add ('staticText', undefined, "Расстояние между маргиналиями: ");
			space = sp.add ('edittext', undefined, convert_units ("6pt", doc_units ()));
			space.characters = 10
		var buttons = w.add ('group');
			buttons.alignment = 'right';
			buttons.orientation = 'row';
			buttons.alignChildren = ['right', 'bottom'];
			buttons.add ('button', undefined, 'Cancel', {name: 'cancel'});
			buttons.add ('button', undefined, 'OK');

	if (app.selection.length > 0 && app.selection[0] instanceof TextFrame && app.selection[0].textFrames.length > 0)
		scope[1].value = true;
	else
		scope[0].value = true;
	
	space.onChange = function () {space.text = convert_units (space.text, doc_units ())}
	
	if (w.show () == 2)
		exit ();
	return {
		position: ["top", "centre", "bottom"][array_index (vpos)],
		target: ["document", "textframe"][array_index (scope)],
		space: Number (convert_units (space.text, "pt").replace (/\spt$/, ""))
		}
	}


function array_index (array)
	{
	for (var i = 0; i < array.length; i++)
		if (array[i].value == true)
			return i;
	}


function convert_units (n, to)
	{
	var m = [];
	m["ag"] = 5.1428571428;
	m["p"] = 12.0000000000;
	m["mm"] = 2.8346456692;
	m["cm"] = 28.3464566929;
	m["in"] = 72.00000000;
	m["c"] = 12.7878751998;
	m["tr"] = 3.0112500000; // traditional point -- but we don't do anything with it yet
	m["pt"] = 1.0000000000;
	obj = fix_measurement (n);
	var temp = (obj.amount * m[obj.unit]) / m[to];
	return output_format (temp, to)
	}


// Add the target unit to the amount, either suffixed pt, ag, mm, cm, in,
// or infixed p or c

function output_format (amount, target)
	{
	amount = amount.toFixed (3).replace (/\.?0+$/g, "");
	if (target.length == 2) // two-character unit: pt, mm, etc.
		return String (amount) + " " + target;
	else // "p" or "c"
		{
		// calculate the decimal
		var decimal = (Number (amount) - parseInt (amount)) * 12;
		// return the integer part of the result + infix + formatted decimal
		return parseInt (amount) + target + decimal;
		}
	}


function fix_measurement (n)
	{
	// infixed "p" and "c" to decimal suffixes: 3p4 > 3.5 p
	n = n.replace (/(\d+)([pc])([.\d]+)$/, function () {return Number (arguments[1]) + Number (arguments[3]/12) + arguments[2]});
	// add unit if necessary
	n = n.replace (/(\d)$/, "$1" + doc_units (app.documents[0]))
	// split on unit
	var temp = n.split (/(ag|cm|mm|c|pt|p|in)$/);
	if (temp.length == 1)
		return {amount: Number (temp[0]), unit: doc_units ()};
	else
		return {amount: Number (temp[0]), unit: temp[1]};
	}


function doc_units ()
	{
	switch (app.documents[0].viewPreferences.horizontalMeasurementUnits)
		{
		case 2051106676: return 'ag';
		case 2053336435: return 'cm';
		case 2053335395: return 'c';
		case 2053729891: return 'in';
		case 2053729892: return 'in';
		case 2053991795: return 'mm';
		case 2054187363: return 'p';
		case 2054188905: return 'pt';
		}
	}

//============================================================================================

function set_measure (unit)
	{
	var doc = app.documents[0];
	var vView = doc.viewPreferences.verticalMeasurementUnits;
	var hView = doc.viewPreferences.horizontalMeasurementUnits;
	doc.viewPreferences.verticalMeasurementUnits = unit;
	doc.viewPreferences.horizontalMeasurementUnits = unit;
	return {v: vView, h: hView}
	}

function restore_measure (obj)
	{
	app.activeDocument.viewPreferences.verticalMeasurementUnits = obj.v;
	app.activeDocument.viewPreferences.horizontalMeasurementUnits = obj.h
	}


function errorM (m) {alert (m); exit ()}